LOCATE(1)

NAME
locate - find filenames quickly

SYNOPSIS
locate [-bcimSs] [-d database] [-l limit] pattern ...

DESCRIPTION
The locate utility searches a database for all pathnames which match the specified pattern. The database is recomputed periodically (usually weekly or daily), and contains the pathnames of all files which are publicly accessible.

Shell globbing and quoting characters (‘*’, ‘’?, ‘\’, ‘[’, and ‘’]) may be used in pattern, although they will have to be escaped from the shell. Preceding any character with a backslash (‘\’) eliminates any special meaning which it may have. The matching differs in that no characters must be matched explicitly, including slashes (‘/’).

As a special case, a pattern containing no globbing characters (“foo”) is matched as though it were “*foo*”.

Historically, locate stores only characters between 32 and 127. The current implementation stores all characters except newline (‘\n’) and NUL (‘\0’). The 8-bit character support does not waste extra space for plain ASCII file names. Characters less than 32 or greater than 127 are stored as 2 bytes.

The options are as follows:

-b  For each entry in the database, perform the search on the last component of path.

-c  Suppress normal output; instead print a count of matching file names.

-d database
    Search in database instead of the default file name database. Multiple -d options are allowed. Each additional -d option adds the specified database to the list of databases to be searched.

    database may be a colon-separated list of databases. An empty database name is a reference to the default database.

        $ locate -d $HOME/lib/mydb: foo

    will first search for the string “foo” in $HOME/lib/mydb and then in /var/db/locate.database.

        $ locate -d $HOME/lib/mydb::/cdrom/locate.database foo

    will first search for the string “foo” in $HOME/lib/mydb and then in /var/db/locate.database and then in /cdrom/locate.database.

        $ locate -d db1 -d db2 -d db3 pattern

    is the same as

        $ locate -d db1:db2:db3 pattern

    or

        $ locate -d db1:db2 -d db3 pattern

    If ‘-’ is given as the database name, standard input will be read instead. For example, you can compress your database and use:

        $ zcat database.gz | locate -d - pattern

    This might be useful on machines with a fast CPU, little RAM and slow I/O. Note: You can only use one pattern for stdin.

-i  Ignore case distinctions in both the pattern and the database.

-l limit
    Limit output to a specific number of files and exit.

-m  Use mmap(2) instead of the stdio(3) library. This is the default behavior. It performs better in most cases.

-S  Print some statistics about the database and exit.

-s  Use the stdio(3) library instead of mmap(2).

ENVIRONMENT
LOCATE_PATH
    Path to the locate database if set and not empty; ignored if the -d option was specified.

FILES
/etc/weekly
    script that starts the database rebuild
/usr/libexec/locate.updatedb
    script to update the locate database
/var/db/locate.database
    locate database

SEE ALSO
find(1), fnmatch(3), locate.updatedb(8), weekly(8) Woods, James A., 1983, Finding Files Fast, ;login, 8:1, pp. 8-10.

HISTORY
The locate command appeared in 4.4BSD.

BUGS
locate may fail to list some files that are present, or may list files that have been removed from the system. This is because locate only reports files that are present in a periodically reconstructed database (typically rebuilt once a week by the weekly(8) script). Use find(1) to locate files that are of a more transitory nature.

The locate database is built by user “nobody” using find(1). This will skip directories which are not readable by user “nobody”, group “nobody”, or the world. E.g., if your home directory is not world-readable, your files will not appear in the database.

The locate database is not byte order independent. It is not possible to share the databases between machines with different byte order. The current locate implementation understands databases in host byte order or network byte order. So a little-endian machine can't understand a locate database which was built on a big-endian machine.